//
//  cctvAppDelegate.m
//  cctv
//
//  Created by Alexandre Berman on 12/26/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "cctvAppDelegate.h"
#import "MainViewController.h"

@implementation cctvAppDelegate

#pragma mark -
#pragma mark Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    
    // Override point for customization after application launch. 
	NSString *smtpHost = [[NSUserDefaults standardUserDefaults] stringForKey:SMTP_HOST_PREF_KEY];
	if (smtpHost != nil)
	{
		// we have prefs saved, let's retrieve them and populate our app
		icctv *model = [icctv sharedicctv];
		model.reportTo = [[NSUserDefaults standardUserDefaults] stringForKey:REPORT_TO_PREF_KEY];
		model.getInstructionsFrom = [[NSUserDefaults standardUserDefaults] stringForKey:GET_INSTRUCTIONS_FROM_PREF_KEY];
		model.Password = [[NSUserDefaults standardUserDefaults] stringForKey:PASSWORD_PREF_KEY];
		model.deviceID = [[NSUserDefaults standardUserDefaults] stringForKey:DEVICE_ID_PREF_KEY];
		model.smtpHost = [[NSUserDefaults standardUserDefaults] stringForKey:SMTP_HOST_PREF_KEY];
	}

    // Add the main view controller's view to the window and display.
    [window addSubview:mainViewController.view];
    [window makeKeyAndVisible];
	// disable screensaver
	application.idleTimerDisabled = YES;
    return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
	icctv *model = [icctv sharedicctv];
	[model doDeActivate];
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}


- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
}


#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}


- (void)dealloc {
    [mainViewController release];
    [window release];
    [super dealloc];
}

@end
